from rest_framework_jwt.authentication import JSONWebTokenAuthentication
from django.utils.functional import SimpleLazyObject


# Workaround simialr to https://github.com/GetBlimp/django-rest-framework-jwt/issues/45 # noqa
class AuthenticationTokenMiddleware:
    """Authentication middleware which return user from token."""

    def __init__(self, get_response):
        """Initializer."""
        self.get_response = get_response

    def __call__(self, request):
        """Response."""
        user = request.user
        request.user = SimpleLazyObject(lambda: self.get_token_user(request,
                                                                    user))
        return self.get_response(request)

    def get_token_user(self, request, user):
        """Return user from DRF token."""
        try:
            authenticator = JSONWebTokenAuthentication()
            return authenticator.authenticate(request)[0]
        except Exception:
            return user


class PermissionMiddleware(object):
    def __init__(self, get_response):
        self.get_response = get_response

    def __call__(self, request):
        response = self.get_response(request)
        return response

    def process_view(self, request, view_func, view_args, view_kwargs):
        print(request.user)
        print(request.POST.get("username"))
        if view_func.__name__ == 'Test':
            print("***************")
        else:
            print("-----------------")
        return view_func(request, *view_args, **view_kwargs)
